#!/usr/bin/perl -w
# $Id: hopify.cgi,v 1.1 2002/09/03 02:05:34 retostamm Exp $

#  Copyright (C) 2000 Reto Stamm

#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#  The License can also be accessed trough http://www.gnu.org/copyleft/gpl.html


use CGI qw(:standard :html3);
use CGI::Carp qw(fatalsToBrowser) ;


my $query = new CGI;

# Fields: text characters lines

# Check if this is the first time the user accesses the page
if (!$query->param("lines")) {
  # DO NOT DELETE THE NEXT LINE
  print "Content-type: text/html\n\n";

  print "<html><head>\n";
  print "<title>Hopify</title>\n"; # Appears in the Browser title bar
  print "</head><body bgcolor = white><h1>SuperReading&reg; Hopify Program</h1>";
  # Draw the form
  print "<form action=hopify.cgi method=post>\n";

  # Dropdown Box for the Nr of Characters
  print "<table><tr><td>Words</td><td><select name=characters>\n";
  print "<option value=\"9\">2<option value=\"14\">3";
  print "<option value=\"18\" selected>4<option value=\"25\">5";
  print "<option value=\"30\">6<option value=\"35\">7<option value=\"40\">8";
  print "<option value=\"45\">9<option value=\"50\">10";
  print "</select></td><td rowspan=5>";
  print "<ol>";
  print "<li>Select electronic text";
  print "<li>Copy";
  print "<li>Paste into Text area below";
  print "<li>Select Words per hop";
  print "<li>Choose Spacing between columns<ul><li>for 2-Word: 6 or 8<li>for 5-Word: 0</ul>";
  print "<li>Click the Hopify button";
  print "<li>Print it out";
  print "</ol>";
  print "</td></tr>\n";

  # Dropdown Box for Nr of lines in a block
#    print "<tr><td>Lines</td><td><select name=lines><option>1";
#    print "<option>2<option>3<option>4<option>5";
#    print "<option>6<option>7<option>8</select></td></tr>\n";
  print "<input type=hidden value=1 name=lines>\n";
  # Dropdown Box for Spacing between columns
  print "<tr><td>Spacing</td><td><select name=spacing><option>0";
  print "<option>1<option>2<option>3<option>4<option>5";
  print "<option>6<option>7<option>8</select></td></tr>\n";

  # Dropdown box for Format
  print "<tr><td>Format</td><td><select name=format><option>Together";
  print "<option>Centered<option>Apart</select></td></tr>\n";
  print "<tr><td>Do it!</td><td><input type=submit name=submit value=\"Hopify!\"></td></tr>\n";
  # Title of text
  print "<tr><td>Title</td><td><input type=text name=title>\n</td></tr>";

  # Text Box
  print "<tr><td valign=top>Text</td><td colspan=2><textarea name=text cols=50 rows=15 wrap=soft></textarea></td></tr>\n";

  # End of form and first page.
  print "<tr><td>Do it!</td><td><input type=submit name=submit value=\"Hopify!\"></td></tr>\n";
  print "</table>\n";
  print "</form><p>\n";
  print '<p><small>SuperReading&reg; Hopify Program by <a href="http://retostamm.com">Reto Stamm</a>, 2000, 2001 ($Revision: 1.1 $)</small>';
  print "</body></html>\n";

} else {

  # Make the Hoppified version.
  print "Content-type: text/html\n\n<html><head></head><body bgcolor = white>";

  # Print the Title
  print "<h1>".$query->param("title")."</h1>\n";

  # Links to more
  print "<a href=hopify.cgi>More Hopify...</a><hr>";

  # retrieve all thce Customers inputs
  my $text = $query->param("text");
  my $lines = $query->param("lines");
  my $characters = $query->param("characters");
  my $format = $query->param("format");
  my $spacing = $query->param("spacing");

  # spacing contains spacing nr of spaces
  $spacing = " " x $spacing;

  # Remove all line break related characters and multiple spaces
  $text =~ s/>/\&gt;/g;
  $text =~ s/</\&lt;/g;

  $text =~ s/\n/ /g;
  $text =~ s/\r/ /g;
  $text =~ s/ +/ /g;

  # Count the lines we have printed in here for the blocking feature.
  my $linecount = -1;

  # Start the Hopify table
  print "<table>";


  # As long as there is text, hopify it.
  while ($text ne "") {
    # Increment the linecount to know when to make empty blocks
    $linecount = $linecount +1;
    
    # If we want to make a block of lines, write out some empty lines
    # and set linecount to 0 again.
    if ($linecount >= $lines) {
      if ($lines != 1) {
        print "\n<tr><td> </td></tr>\n";
        print "\n<tr><td> </td></tr>\n";
        print "\n<tr><td> </td></tr>\n";
        print "\n<tr><td> </td></tr>\n";        
        $linecount = 0;
      }

    }

    # A scoop is a group of words. Scoop1 is on the left, scoop2 is on
    # the right.
    my $scoop1 = $text;
    # Remove all except $characters (and the next whole word) from the
    # scoop.
    $scoop1 =~ s/(.{$characters}[^ -]*).*/$1/;
    # Remove the Scoop from the text to be processed (it kind of is
    # processed now.
    $text =~ s/(.{$characters}[^ -]*) *(.*)/$2/;

    # Same story for scoop 2.
    my $scoop2 = $text;
    $scoop2 =~ s/(.{$characters}[^ -]*).*/$1/;
    $text =~ s/(.{$characters}[^ -]*) *(.*)/$2/;

    # This is the end of file detection. It's primitive and sometimes
    # makes an ugly last line, but works and does not hang the server.
    if ($scoop1 eq $scoop2) {
    # Depending on the format, write a line with two scoops
    if ($format eq "Together") {
      print "<tr><td align=right>$scoop1</td><td><pre>$spacing<pre></td><td align=left></td></tr>\n";
    }
    if ($format eq "Apart") {
      print "<tr><td align=left>$scoop1</td><td><pre>$spacing<pre></td><td align=right></td></tr>\n";
    }
    if ($format eq "Centered") {
      print "<tr><td align=center>$scoop1</td><td><pre>$spacing<pre></td><td align=center></td></tr>\n";
    }
      $text = "";
      $format = "doomed";
    }

    # Depending on the format, write a line with two scoops
    if ($format eq "Together") {
      print "<tr><td align=right>$scoop1</td><td><pre>$spacing<pre></td><td align=left>$scoop2</td></tr>\n";
    }
    if ($format eq "Apart") {
      print "<tr><td align=left>$scoop1</td><td><pre>$spacing<pre></td><td align=right>$scoop2</td></tr>\n";
    }
    if ($format eq "Centered") {
      print "<tr><td align=center>$scoop1</td><td><pre>$spacing<pre></td><td align=center>$scoop2</td></tr>\n";
    }

    if ($scoop2 eq $text) {
        $text = "";
    }
  } # End of While loop

  # That's it.
  print "</table>";
  print '<p><small>Hopified with the SuperReading&reg; Hopify Program by <a href="http://retostamm.com">Reto Stamm</a>, 2000, 2001 ($Revision: 1.1 $)</small>';
  print "</body></html>\n";
} 
